var blessed = require('neo-blessed');


// Initialize the screen widget.
var screen = blessed.screen({
	// Example of optional settings:
	smartCSR: true,
	useBCE: true,
	cursor: {
		artificial: true,
		blink: true,
		shape: 'underline'
	},
	log: `${__dirname}/application.log`,
	debug: true,
	dockBorders: true
});

// Specify the title of the application.
screen.title = 'GraphQURL';

var ta = blessed.textarea({
  parent: screen,
  inputOnFocus: true,
  vi: true,
  mouse: true,
  keys: true,
  name: 'query'
});

var list = blessed.list({
  items: ['query', 'table1', 'table2', 'column1', 'column2'],
  keys: true,
  vi: true
});

screen.key(['q', 'C-c'], function() {
  process.exit(0);
});

screen.key('i', function() {
  ta.focus();
});

ta.key(['C-n'], function() {
  list.focus();
});

screen.render();
