const tk = require( 'terminal-kit' );

var term = tk.terminal;

let querystring = [];

term.fullscreen(true);

var autoComplete = [
	'dnf install' ,
	'dnf install nodejs' ,
	'dnf search' ,
	'sudo' ,
	'sudo dnf install' ,
	'sudo dnf install nodejs' ,
	'sudo dnf search' ,
] ;

const inputLine = () => {
  term.saveCursor();
  term('gql> ');
  term.inputField({
		autoComplete: autoComplete ,
		autoCompleteHint: true ,
		autoCompleteMenu: true 
  }, (error, input) => {
    if (error) {
      console.log('error happened');
      console.log(error);
      terminate();
    } else {
      term.restoreCursor();
      term.eraseLine();
      const numLines = querystring.length;
      if (numLines > 0) {
        term.previousLine(numLines);
        term.deleteLine(numLines);
      }
      querystring.push(input);
      term(querystring.join('\n'));
      term.nextLine(1);
      return inputLine();
    }
  });
};

const getNumLines = (doc) => {
  return doc.split(/\r\n|\r|\n/).length;
};

inputLine();

term.on( 'key' , function( key ) {
	if ( key === 'CTRL_C' )
	{
		term.green( 'CTRL-C detected...\n' ) ;
		terminate() ;
	}
} ) ;



function terminate()
{
	term.grabInput( false ) ;
  term.fullscreen(false);
	// Add a 100ms delay, so the terminal will be ready when the process effectively exit, preventing bad escape sequences drop
	setTimeout( function() { process.exit() ; } , 100 ) ;
}
